{
my number is 06

This file includes source code of Server application

this file needs _06Shared unit
}

unit _06SrvMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ScktComp, _06Shared;

const
 MaxClients=100;                 //clients limitation can be changed
 GivenRange=1000;                //maximum range of interval for clients

 {range array const}
 raMax=MaxInt div GivenRange+1;  //maximum RangeArray index

 //RangeArray states
 raReady=0;                      //we need to count this part
 raRunning=1;                    //someone is counting this part now
 raDone=2;                       //this part is done

type
  TForm1 = class(TForm)
    Server: TServerSocket;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ServerAccept(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
  private
    { Private declarations }
  public
   Port:Word;
   ClientsData:array[1..MaxClients] of record    //record for data about clients
    ID:Integer;                  //its handle (identificator)
    IsFull:Boolean;              //flag is set when this client exists
    Range:Integer;               //pointer to RangeArray array
   end;

   //big interval 0..2^32-1 divided in parts (each part is 1000 long)
   RangeArray:array[0..raMax] of Byte;

   Low,Hi,RangeCoefDiv,RangeCoefMod,MaxRangeIndex,WorkToDo:Integer;
   PerDone:Byte;                 //computation progress

   F:TextFile;                   //output file
   FileCounter:Integer;          //its counter for saving

   procedure SendIDNetBuffer(Socket: TCustomWinSocket);
   procedure SendWork(Index:Integer);
   function GetClientsIndex(Socket: TCustomWinSocket):Integer;
   procedure SendNetBuffer(Index:Integer);
   procedure ClientOut(Socket:TCustomWinSocket);
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
//starts the server
begin
 Port:=StrToIntDef(Edit1.Text,DefPort);
 Low:=StrToIntDef(Edit2.Text,0);
 Hi:=StrToIntDef(Edit3.Text,MaxInt);
 RangeCoefDiv:=Hi div GivenRange;
 RangeCoefMod:=Low mod GivenRange;
 MaxRangeIndex:=RangeCoefDiv;
 WorkToDo:=MaxRangeIndex;
 Server.Port:=Port;
 Server.Active:=True;
end; {Button1Click}

procedure TForm1.FormCreate(Sender: TObject);
//initializaton
begin
 ZeroMemory(@ClientsData,SizeOf(ClientsData));
 ZeroMemory(@RangeArray,SizeOf(RangeArray));
 Port:=DefPort;
 Edit3.Text:=IntToStr(MaxInt);
 AssignFile(F,'06Output.txt');
 Rewrite(F);
end; {FormCreate}

procedure TForm1.ServerAccept(Sender: TObject; Socket: TCustomWinSocket);
//handling accepting new client
var
 I:Integer;
 Accepted:Boolean;
begin
 Accepted:=False;
 for I:=1 to MaxClients do
 if not ClientsData[I].IsFull then
 begin
  Accepted:=True;
  ClientsData[I].IsFull:=True;
  ClientsData[I].ID:=Socket.SocketHandle;
  NetBuffer.BType:=btGetID;
  NetBuffer.D1:=ClientsData[I].ID;
  SendIDNetBuffer(Socket);
  Break;
 end;
 if not Accepted then Socket.Close;
end; {ServeAccept}

procedure TForm1.SendIDNetBuffer(Socket: TCustomWinSocket);
//sends ID to the new client
begin
 Socket.SendBuf(NetBuffer,SizeOf(NetBuffer));
end; {SendIDNetbuffer}

procedure TForm1.ServerClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
//handling of receiving buffer
var
 Index:Integer;
begin
 Index:=GetClientsIndex(Socket);
 if Index=-1 then Exit;

 Socket.ReceiveBuf(NetBuffer,SizeOf(NetBuffer));
 with NetBuffer do
 begin
  case BType of
   btWannaWork:begin
    SendWork(Index);
   end;
   btGetPrimeNumber:begin
    WriteLn(F,D1);
   end;
   btEndOfRange:begin
    RangeArray[ClientsData[Index].Range]:=raDone;
    Dec(WorkToDo);
    PerDone:=Round(((MaxRangeIndex+1)-WorkToDo)/(MaxRangeIndex+1)*100);
    Label4.Caption:='Status: '+IntToStr(PerDone)+'% done';
    if FileCounter=0 then
    begin
     CloseFile(F);
     if WorkToDo>0 then Append(F)
     else
     begin
      Server.Close;
      Halt
     end;
    end;
   end;
  end;
 end;
end; {ServerClientRead}

procedure TForm1.ServerClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
//when the client died
begin
 ClientOut(Socket);
end; {ServeClientDisconnect}

procedure TForm1.ServerClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
//also when the client died or some error is ocured
begin
 ClientOut(Socket);
end; {ServerClientError}

function TForm1.GetClientsIndex(Socket: TCustomWinSocket):Integer;
//finds a client defined by Socket
var I:Integer;
begin
 Result:=-1;
 for I:=1 to Server.Socket.ActiveConnections do
 if Socket.SocketHandle=ClientsData[I].ID then
 begin
  Result:=I;
  Break;
 end;
end; {GetClientsIndex}

procedure TForm1.SendWork(Index:Integer);
//this sends interval to client (it will be his work)
var
 I,LD,HD:Integer;
begin
 for I:=0 to MaxRangeIndex do
 if RangeArray[I]=raReady then
 begin
  with NetBuffer do
  begin
   BType:=btHereIsYerWork;
   LD:=I*GivenRange+RangeCoefMod;
   if LD>Hi-1000 then HD:=Hi
   else HD:=LD+GivenRange-1;
   D1:=LD;
   D2:=HD;
  end;

  ClientsData[Index].Range:=I;
  RangeArray[I]:=raRunning;
  SendNetBuffer(Index);
  Break;
 end;
 if WorkToDo=0 then
 begin
  NetBuffer.BType:=btAllIsOver;
  SendNetBuffer(Index);
 end;
end; {SendWork}

procedure TForm1.SendNetBuffer(Index:Integer);
//sends NetBuffer in itself
var I:Integer;
begin
 for I:=0 to Server.Socket.ActiveConnections-1 do
 with Server.Socket do
 if Connections[I].SocketHandle=ClientsData[Index].ID then
 begin
  Connections[I].SendBuf(NetBuffer,SizeOf(NetBuffer));
  Break;
 end;
end; {SendNetBuffer}

procedure TForm1.ClientOut(Socket:TCustomWinSocket);
//when client died .... we will delete his values
var
 Index:Integer;
begin
 Index:=GetClientsIndex(Socket);
 if Index=-1 then Exit;
 ClientsData[Index].IsFull:=False;
 RangeArray[ClientsData[Index].Range]:=raReady;
end; {ClientOut}

end.
